local currentCopper = 0
local currentFaction = nil

SLASH_GOLDTRACKER1 = "/gt"

--hook variables
local _Quit = Quit
local _Logout = Logout
local _ReloadUI = ReloadUI
local _ConsoleExec = ConsoleExec


local GT_frame = CreateFrame("FRAME", "GT_frame", UIParent);
GT_frame:SetMovable(true);
GT_frame:EnableMouse(true);
GT_frame:RegisterForDrag("LeftButton");
GT_frame:SetScript("OnDragStart", GT_frame.StartMoving);
GT_frame:SetScript("OnDragStop", GT_frame.StopMovingOrSizing);

--makes frame visable
GT_frame:SetPoint("CENTER");
GT_frame:SetWidth(128);
GT_frame:SetHeight(64);

local backdrop = {
  -- path to the background texture
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Dragon",  
  -- path to the border texture
  --edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Dragon",
  -- true to repeat the background texture to fill the frame, false to scale it
  tile = false,
  -- size (width or height) of the square repeating background tiles (in pixels)
  tileSize = 32,
  -- thickness of edge segments and square size of edge corners (in pixels)
  edgeSize = 0,
  -- distance from the edges of the frame to those of the background texture (in pixels)
  insets = {
    left = -33,
    right = 33,
    top = -7,
    bottom = 7
  }
}
GT_frame:SetBackdrop(backdrop);
GT_frame:SetAlpha(1.0);
                    

--create reset button
GT_frame.resetButton = CreateFrame("BUTTON", "resetButton", GT_frame, "UIPanelButtonTemplate")
GT_frame.resetButton:SetPoint("BOTTOMRIGHT", GT_frame, -12, 10)
GT_frame.resetButton:SetWidth(32)
GT_frame.resetButton:SetHeight(16)

--create font object for reset button
local f = CreateFont("f")
f:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
f:SetTextColor( 0.7, 0.6, 0)
local f2 = CreateFont("f2")
f2:SetFont("Fonts\\FRIZQT__.TTF", 8, "OUTLINE")
f2:SetTextColor( 1, 1, 1)


GT_frame.resetButton:SetNormalFontObject(f)
GT_frame.resetButton:SetHighlightFontObject(f2)
GT_frame.resetButton:SetText("Reset")

GT_frame.resetButton:SetScript("OnClick",
  function() 
    goldEarned = 0
    numSessions[currentFaction] = numSessions[currentFaction] + 1
    ChatFrame1:AddMessage("GoldTracker: Starting new session as... "..currentFaction)
    if estGoldPerHour < 0 and goldInfoTable[currentDate..':'..currentFaction] < 0 then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString((goldEarned), 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: -".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8))
    elseif goldInfoTable[currentDate..':'..currentFaction] < 0 then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString((goldEarned), 8).. "\nLast Hour: -".. GetCoinTextureString((estGoldPerHour), 8).."\nToday: -".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8))
    elseif (estGoldPerHour < 0) then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif goldEarned < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: ".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    else
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: ".. GetCoinTextureString(estGoldPerHour, 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8)) 
    end
  end)
--create a fontstring
GT_frame.text = GT_frame:CreateFontString(nil, "ARTWORK") --Create a FontString to display text
GT_frame.text:SetFont("Fonts\\FRIZQT__.TTF", 9) --Set the font and size
GT_frame.text:SetTextColor(1, 1, 1) --Set the text colour
GT_frame.text:SetJustifyH("LEFT")
GT_frame.text:SetJustifyV("TOP")
GT_frame.text:SetPoint("TOPLEFT", GT_frame, 12, -10) --Put it in the top left
GT_frame.text:SetText("error");

GT_frame:RegisterEvent("ADDON_LOADED");
GT_frame:RegisterEvent("PLAYER_MONEY");
GT_frame:RegisterEvent("PLAYER_ENTERING_WORLD");

SlashCmdList["GOLDTRACKER"] = function(message, editbox)
                                GT_frame:SlashHandler(message, editbox) 
                              end
function calcChangeInGold(currentSecPlay)
 
    
       accumulator = 0
     --winner = currentSecPlay
    for i, v in pairs(goldEarnedTable) do
      if (currentSecPlay-i) <= (3600) then
        accumulator = accumulator + v
      end
    end
   -- local ge = goldEarnedTable[currentSecPlay] - goldEarnedTable[winner]
    return accumulator
  
end
function GT_frame:SlashHandler(message, editbox)
  
  if GT_frame:IsShown() then
    GT_frame:Hide()
  
  else
    GT_frame:Show();
  end 
end
function GT_frame:PLAYER_MONEY(...)
  local goldMade = ((GetMoney() - currentCopper));
  --secondsPlayed = time() - loginTime
  goldEarned = goldEarned + goldMade
  goldEarnedTable[time()] = goldMade --store gold made into gold earned table
  estGoldPerHour = calcChangeInGold(time())
  ChatFrame1:AddMessage("|TInterface\\Icons\\INV_Misc_Coin_01:16:16:0:0:64:64:4:60:4:60|tMade exactly ".. goldMade / 10000 .." Gold");
  goldInfoTable[currentDate..':'..currentFaction] = goldInfoTable[currentDate..':'..currentFaction] + goldMade
  
    if estGoldPerHour < 0 and goldEarned < 0 and goldInfoTable[currentDate..':'..currentFaction] < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: -".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8))
    elseif (estGoldPerHour < 0) and goldEarned < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif (estGoldPerHour < 0) then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif goldEarned < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: ".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif goldInfoTable[currentDate..':'..currentFaction] < 0 then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: ".. GetCoinTextureString(estGoldPerHour, 8).."\nToday: -".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8)) 
    else
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: ".. GetCoinTextureString(estGoldPerHour, 8).."\nToday: ".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8)) 
    end

  
  currentCopper = GetMoney();
  
end

function GT_frame:PLAYER_ENTERING_WORLD(...)
  currentCopper = GetMoney();
end

function GT_frame:ADDON_LOADED(name)
  
  
  if name == "GoldTracker" then
    
    currentFaction = UnitFactionGroup("Player");
    currentDate = date("%x")
    
    if type(currentSession) ~= "boolean" then
      currentSession = true
      loginTime = time()
      goldEarnedTable = {}
      goldEarnedTable[loginTime] = 0
      estGoldPerHour = 0
    end
    
    if type(goldEarned) ~= "number" then
      goldEarned = 0 
    else
      if currentSession == false then
        goldEarned = 0
        currentSession = true
      end
    end
    
    if type(goldInfoTable) ~= "table" then
      goldInfoTable = {}
      goldInfoTable[currentDate..':'..currentFaction] = {}
      goldInfoTable[currentDate..':'..currentFaction] = 0
      
    else
      if goldInfoTable[currentDate..':'..currentFaction] == nil then
        goldInfoTable[currentDate..':'..currentFaction] = 0
        
      end
    end
  
    
    if type(numSessions) ~= "table" then
      numSessions = {}
      numSessions[currentFaction] = 0
    else
      if numSessions[currentFaction] == nil then
        numSessions[currentFaction]=0
      end
    end
    
    if type(totalGoldEarned) ~= "table" then
        totalGoldEarned = {}
        totalGoldEarned[currentFaction]=0
    else
      if totalGoldEarned[currentFaction] == nil then
        totalGoldEarned[currentFaction]=0
      end
    end
    
  
    
    ChatFrame1:AddMessage("Gold Tracker v0.51 loaded");
    if numSessions[currentFaction] == 0 then
      ChatFrame1:AddMessage("Todays Date: "..currentDate.."\n"..currentFaction.." Sessions Tracked: ".. numSessions[currentFaction].. "\nAverage Gold Per "..currentFaction.." Session: None Yet!" .."\nTotal Gold Earned as "..currentFaction..":".. floor(totalGoldEarned[currentFaction] / 100 / 100));
    GT_frame.text:SetText("Session: ".. GetCoinTextureString((goldEarned), 8).. "\nLast Hour: "..GetCoinTextureString(estGoldPerHour, 8).."\nToday: "     ..GetCoinTextureString((goldInfoTable[currentDate..':'..currentFaction]), 8));
    else
    ChatFrame1:AddMessage("Todays Date: "..currentDate.."\n"..currentFaction.." Sessions Tracked: ".. numSessions[currentFaction].. "\nAverage Gold Per "..currentFaction.." Session: " .. floor(totalGoldEarned[currentFaction]/numSessions[currentFaction]/ 100 / 100) .."\nTotal Gold Earned as "..currentFaction..":".. floor(totalGoldEarned[currentFaction]/ 100 / 100).."\nGold Earned Today: "     ..GetCoinTextureString((abs(goldInfoTable[currentDate..':'..currentFaction]))));
    if estGoldPerHour < 0 and goldEarned < 0 and goldInfoTable[currentDate..':'..currentFaction] < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: -".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8))
    elseif (estGoldPerHour < 0) and goldEarned < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif (estGoldPerHour < 0) then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: -".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif goldEarned < 0 then
      GT_frame.text:SetText("Session: -".. GetCoinTextureString(abs(goldEarned), 8).. "\nLast Hour: ".. GetCoinTextureString(abs(estGoldPerHour), 8).."\nToday: ".. GetCoinTextureString(goldInfoTable[currentDate..':'..currentFaction], 8))
    elseif goldInfoTable[currentDate..':'..currentFaction] < 0 then
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: ".. GetCoinTextureString(estGoldPerHour, 8).."\nToday: -".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8)) 
    else
      GT_frame.text:SetText("Session: ".. GetCoinTextureString(goldEarned, 8).. "\nLast Hour: ".. GetCoinTextureString(estGoldPerHour, 8).."\nToday: ".. GetCoinTextureString(abs(goldInfoTable[currentDate..':'..currentFaction]), 8)) 
    end
    end
  
  end
end

GT_frame:SetScript("OnEvent", function(self, event, ...)
    GT_frame[event](self,...); -- call one of above funtions
end)
--hook functions
function Quit()
  numSessions[currentFaction] = numSessions[currentFaction] + 1
  totalGoldEarned[currentFaction] = totalGoldEarned[currentFaction] + goldEarned
  currentSession = false
  return _Quit()
end
function Logout()
  numSessions[currentFaction] = numSessions[currentFaction] + 1
  totalGoldEarned[currentFaction] = totalGoldEarned[currentFaction] + goldEarned
  currentSession = false
  return _Logout()
end
function ReloadUI()
    -- do something
    return _ReloadUI()
end
function ConsoleExec(msg)
    if strlower(msg) == "reloadui" then
        currentSession = true
    end
    return _ConsoleExec(msg)
end